=== debian/changelog ===
hypre (2.28.0-2) unstable; urgency=medium

  * Team upload.
  * push HYPRE 2.28.0 to unstable. Transition #1042005.

 -- Drew Parsons <dparsons@debian.org>  Sat, 05 Aug 2023 17:29:43 +0200

hypre (2.28.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.
  * drop deprecated debian patch pilut_blas_mangle.patch. External
    BLAS handling fixed in PR#36 (commit a16e7b3 for PETSc 2.18).
    See also commit 5afacfc in PR#827.
  * debian/tests: launch runtest.sh explicitly via bash to avoid
    problems from hashbang #!/bin/sh (script uses function keyword)
    See https://github.com/hypre-space/hypre/issues/881

 -- Drew Parsons <dparsons@debian.org>  Sun, 16 Apr 2023 18:20:50 +0200

hypre (2.27.0-1exp1) experimental; urgency=medium

  * Team upload.
  * New upstream release.

 -- Drew Parsons <dparsons@debian.org>  Sat, 31 Dec 2022 11:05:53 +0100
